﻿local L = LibStub("AceLocale-3.0"):GetLocale("Mounted", false)
local Mounted = Mounted

local MOUNT_GROUND = 'g'
local MOUNT_FLYING = 'f'
local MOUNT_BOTH = 'both'

local SPEED_ADAPTS = 'variable'
local SPEED_SLOW = {
	['g'] = '60',
	['f'] = '60',
}
local SPEED_MEDIUM = {
	['g'] = '100',
	['f'] = '280',
}
local SPEED_FAST = {
	['f'] = '310',
}

local mountBypass = {
	[54729] = {speed=SPEED_ADAPTS, mountpack={'f','60','f','280'}}, -- Winged Steed of the Ebon Blade
	[58983] = {speed=SPEED_ADAPTS, mountpack={'g','60','g','100'}}, -- Big Blizzard Bear
	[48025] = {speed=SPEED_ADAPTS, mountpack={'g','60','g','100','f','60','f','280'}}, -- Headless Horseman's Mount
	[30174] = { mountType=MOUNT_GROUND, speed='0' }, -- Turtle Mount
	[25953] = { mountType=MOUNT_GROUND, speed='aq' }, -- Blue Qiraji Battle Tank
	[26056] = { mountType=MOUNT_GROUND, speed='aq' }, -- Green Qiraji Battle Tank
	[26054] = { mountType=MOUNT_GROUND, speed='aq' }, -- Red Qiraji Battle Tank
	[26055] = { mountType=MOUNT_GROUND, speed='aq' }, -- Yellow Qiraji Battle Tank
	[59976] = { mountType=MOUNT_FLYING, speed='310' }, --Black Proto-Drake
	[60021] = { mountType=MOUNT_FLYING, speed='310' }, --Plagued Proto-Drake
	[60024] = { mountType=MOUNT_FLYING, speed='310' }, --Violet Proto-Drake
	[40192] = { mountType=MOUNT_FLYING, speed='310' }, --Ashes of Al'ar
	[44151] = { mountType=MOUNT_FLYING, speed='280' }, --Turbo-Charged Flying Machine
	[579] = { mountType=MOUNT_GROUND, speed='100' }, --Red Wolf
	----- add spell ids so that these dont get deleted :)
	[40120] = { mountType=MOUNT_FLYING, speed='280' }, --swift flight
	[33943] = { mountType=MOUNT_FLYING, speed='60' }, --flight
	[783] = { mountType=MOUNT_GROUND, speed='40' }, --travel
	[2645] = { mountType=MOUNT_GROUND, speed='40' }, --travel
}
local Scanner = CreateFrame("GameTooltip", "Critters_ScannerTooltip", nil, "GameTooltipTemplate")
Scanner:SetOwner(UIParent, "ANCHOR_NONE")
for i = 1, 30 do
	Scanner[i] = _G["Critters_ScannerTooltipTextLeft"..i]
	if not Scanner[i] then
		Scanner[i] = Scanner:CreateFontString()
		Scanner:AddFontStrings(Scanner[i], Scanner:CreateFontString())
	end
end

local mountscache = {}
function Mounted:MountType(spellid)
	if mountscache[spellid] then return mountscache[spellid] end
	local mountpack = {} -- odd numbers are mount types evens are speeds multible once mean scaling mounts
	if( mountBypass[spellid] ) then
		if mountBypass[spellid].speed == SPEED_ADAPTS then
			mountpack = mountBypass[spellid].mountpack
		else
			mountpack[1] = mountBypass[spellid].mountType
			mountpack[2] = mountBypass[spellid].speed
		end
	else
		Scanner:ClearLines()
		Scanner:SetHyperlink("spell:"..spellid)
		local _, _, Outland, Northrend = GetMapContinents()
		local numLines = Scanner:NumLines()
		local text = ""
		for i=1,numLines do
			text = string.format("%s %s", text, Scanner[i]:GetText())
		end
		if text:match(Outland) or text:match(Northrend) then
			mountpack[1] = MOUNT_FLYING
		else
			mountpack[1] = MOUNT_GROUND
		end
		if text:match(L.SpeedFast) then
			mountpack[2] = SPEED_FAST[mountpack[1]]
		elseif text:match(L.SpeedMedium) then
			mountpack[2] = SPEED_MEDIUM[mountpack[1]]
		else
			mountpack[2] = SPEED_SLOW[mountpack[1]]
		end
	end
	return mountpack
end

